---
# Don't forget to keep this file updated
# molecule/<scenario>/verify.yml
- name: "Verify"
  hosts: "cicd-debian-12"
  gather_facts: false
  tasks:

    - name: "Check the state of nodes in the cluster on Manager"
      when: "inv__install_docker_swarm_is_manager | default(false)"
      register: "docker_command_result"
      failed_when: "'Leader' not in docker_command_result.stdout"
      ansible.builtin.shell: |
        docker node ls

    - name: "Check the state of nodes in the cluster on Worker"
      when: "not inv__install_docker_swarm_is_manager | default(false)"
      register: "docker_command_result"
      failed_when: "'This node is not a swarm manager' not in docker_command_result.stderr_lines[0]"
      ansible.builtin.shell: |
        docker node ls

    - name: "Check the state of services in the Portainer stack on Manager"
      when: "inv__install_docker_swarm_is_manager | default(false)"
      register: "docker_command_result"
      failed_when: "'portainer' not in docker_command_result.stdout"
      ansible.builtin.shell: |
        docker service ls --filter label=com.docker.stack.namespace=portainer

    - name: "Filter nodes by role (Manager)"
      when: "inv__install_docker_swarm_is_manager | default(false)"
      register: "docker_command_result"
      failed_when: "docker_command_result.stdout == ''"
      ansible.builtin.shell: |
        docker node ls --filter role=manager

    - name: "Filter nodes by role (Workers)"
      when: "inv__install_docker_swarm_is_manager | default(false)"
      register: "docker_command_result"
      failed_when: "docker_command_result.stdout == ''"
      ansible.builtin.shell: |
        docker node ls --filter role=worker
